# Practitioner _search

`POST /Practitioner/_search`

This resource includes details about an individual at a healthcare organization. The individual may range from those indirectly responsible for patient treatment or services (e.g., receptionists, IT personnel) to those directly responsible for patient treatment or services (e.g., physicians, pharmacists, therapists). However, this resource doesn’t include people related to the patient like a caregiver. 

You can review, retrieve, or update practitioner records in bulk.

> **Supported fields and schema examples**
>
> We support any valid FHIR field. However, we only display fields we’ve defined in our schema, which are usually based on what’s included in the U.S. Core profile. We recommend relying on U.S. Core requirements. 
>
> Our schema examples show the shape and possibility of each FHIR resource; they aren’t code for real-time API calls. We don’t currently recommend copying and pasting these schema examples for your API calls. [Consider reviewing FHIR API actions](/fhir-api-actions) for realistic examples for particular use cases.

### \_search

Query for practitioner records. 

> **Flexible FHIR queries, different query parameters**
>
> FHIR queries are a flexible option with parameters to refine your search. The response returns a bundle of resources, known as a `searchset` bundle type. [Learn about bundles and bundle types](https://docs.redoxengine.com/permalink/23Q1Oku3NdxxvwYnQGJVrg) in our FHIR glossary.
>
> We add a `required` label only to query parameters _a FHIR server requires if you query it directly_. Remember that Redox <u>**data on demand**</u> isn’t a FHIR server, and your connection may not be either.
>
> _Query parameters vary between sites._ Work with your connection to find out which query parameters they require for a successful search.

## Request body

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `identifier` | Array of string | No | One or more external identifiers for the practitioner |
| `given` | Array of string | No | A portion of the given name of the practitioner |
| `family` | Array of string | No | A portion of the family name of the practitioner |
| `name` | Array of string | No | A portion of the name of the practitioner |

## Request example

_Generated from the schema: the values are placeholders, not a real payload._

```bash
curl 'https://api.redoxengine.com/fhir/R4/{destinationSlug}/{environmentFlag}/Practitioner/_search' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'identifier=string' \
--data-urlencode 'given=string' \
--data-urlencode 'family=string' \
--data-urlencode 'name=string'
```

## Responses

### 200

Search results (Bundle)

Response to a Practitioner search operation containing only practitioner resources

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: Bundle |
| `type` | string | Yes | Identifies this bundle as a response to a search. Value: searchset |
| `total` | number | Yes | The total number of matches |
| `entry` | Array of Practitioner or Other | No | A resource matching the search criteria or related to a matching resource |
| `entry[] (Practitioner).resource` | object | Yes | Information about a healthcare practitioner |
| `entry[] (Practitioner).resource.resourceType` | string | Yes | Identifies the type of the resource. Value: Practitioner |
| `entry[] (Practitioner).resource.identifier` | Array of NPI or Other | Yes | An identifier that applies to this person in this role. |
| `entry[] (Practitioner).resource.identifier[] (NPI).system` | string | Yes | Establishes the namespace for the value - that is, a URL that describes a set values that are unique. Value: http://hl7.org/fhir/sid/us-npi |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension` | Array of Boolean or String or CodeableConcept or Coding or HumanName or Reference | No | May be used to represent additional information that is not part of the basic definition of the element. To make the use of extensions safe and manageable, there is a strict set of governance  applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Boolean).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Boolean).valueBoolean` | boolean | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (String).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (String).valueString` | string | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).valueCodeableConcept` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).valueCodeableConcept.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).valueCodeableConcept.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).valueCodeableConcept.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (CodeableConcept).valueCodeableConcept.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Coding).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Coding).valueCoding` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Coding).valueCoding.system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Coding).valueCoding.code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (HumanName).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (HumanName).valueHumanName` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (HumanName).valueHumanName.use` | string | No | Identifies the purpose for this name. Possible values: usual, official, temp, nickname, anonymous, old, maiden |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (HumanName).valueHumanName.family` | string | No | The part of a name that links to the genealogy. In some cultures (e.g. Eritrea) the family name of a son is the first name of his father. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (HumanName).valueHumanName.given` | Array of string | No | Given name. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Reference).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Reference).valueReference` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (NPI).extension[] (Reference).valueReference.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Practitioner).resource.identifier[] (NPI).use` | string | No | The purpose of this identifier. Possible values: usual, official, temp, secondary, old (If known) |
| `entry[] (Practitioner).resource.identifier[] (NPI).value` | string | No | The portion of the identifier typically relevant to the user and which is unique within the context of the system. |
| `entry[] (Practitioner).resource.identifier[] (Other).system` | string | Yes | Establishes the namespace for the value - that is, a URL that describes a set values that are unique. |
| `entry[] (Practitioner).resource.identifier[] (Other).value` | string | Yes | The portion of the identifier typically relevant to the user and which is unique within the context of the system. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension` | Array of Boolean or String or CodeableConcept or Coding or HumanName or Reference | No | May be used to represent additional information that is not part of the basic definition of the element. To make the use of extensions safe and manageable, there is a strict set of governance  applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Boolean).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Boolean).valueBoolean` | boolean | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (String).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (String).valueString` | string | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).valueCodeableConcept` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).valueCodeableConcept.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).valueCodeableConcept.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).valueCodeableConcept.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (CodeableConcept).valueCodeableConcept.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Coding).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Coding).valueCoding` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Coding).valueCoding.system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Coding).valueCoding.code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (HumanName).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (HumanName).valueHumanName` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (HumanName).valueHumanName.use` | string | No | Identifies the purpose for this name. Possible values: usual, official, temp, nickname, anonymous, old, maiden |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (HumanName).valueHumanName.family` | string | No | The part of a name that links to the genealogy. In some cultures (e.g. Eritrea) the family name of a son is the first name of his father. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (HumanName).valueHumanName.given` | Array of string | No | Given name. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Reference).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Reference).valueReference` | object | No | A single value for the extension. |
| `entry[] (Practitioner).resource.identifier[] (Other).extension[] (Reference).valueReference.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Practitioner).resource.identifier[] (Other).use` | string | No | The purpose of this identifier. Possible values: usual, official, temp, secondary, old (If known) |
| `entry[] (Practitioner).resource.name` | Array of object | Yes | The name(s) associated with the practitioner. |
| `entry[] (Practitioner).resource.name[].family` | string | Yes | The part of a name that links to the genealogy. In some cultures (e.g. Eritrea) the family name of a son is the first name of his father. |
| `entry[] (Practitioner).resource.name[].use` | string | No | Identifies the purpose for this name. Possible values: usual, official, temp, nickname, anonymous, old, maiden |
| `entry[] (Practitioner).resource.name[].given` | Array of string | No | Given name. |
| `entry[] (Practitioner).resource.id` | string | No | The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes. |
| `entry[] (Practitioner).resource.active` | boolean | No | Whether this practitioner's record is in active use. |
| `entry[] (Practitioner).resource.telecom` | Array of object | No | A contact detail for the practitioner, e.g. a telephone number or an email address. |
| `entry[] (Practitioner).resource.telecom[].system` | string | No | Telecommunications form for contact point - what communications system is required to make use of the contact. Possible values: phone, fax, email, pager, url, sms, other |
| `entry[] (Practitioner).resource.telecom[].value` | string | No | The actual contact point details, in a form that is meaningful to the designated communication system (i.e. phone number or email address). |
| `entry[] (Practitioner).resource.telecom[].use` | string | No | Identifies the purpose for the contact point. Possible values: home, work, temp, old, mobile |
| `entry[] (Practitioner).resource.address` | Array of object | No | Address(es) of the practitioner |
| `entry[] (Practitioner).resource.address[].line` | Array of string | No | This component contains the house number, apartment number, street name, street direction,  P.O. Box number, delivery hints, and similar address information. |
| `entry[] (Practitioner).resource.address[].city` | string | No | The name of the city, town, suburb, village or other community or delivery center. |
| `entry[] (Practitioner).resource.address[].state` | string | No | Sub-unit of a country with limited sovereignty in a federally organized country. A code may be used if codes are in common use (e.g. US 2 letter state codes). |
| `entry[] (Practitioner).resource.address[].postalCode` | string | No | A postal code designating a region defined by the postal service. |
| `entry[] (Practitioner).resource.address[].country` | string | No | Country - a nation as commonly understood or generally accepted. |
| `entry[] (Practitioner).resource.address[].use` | string | No | The purpose of this address. Possible values: home, work, temp, old, billing |
| `entry[] (Practitioner).resource.address[].district` | string | No | The name of the administrative area (county). |
| `entry[] (Practitioner).resource.gender` | string | No | Administrative Gender - the gender that the person is considered to have for administration and record keeping purposes. Possible values: male, female, other, unknown |
| `entry[] (Practitioner).resource.qualification` | Array of object | No | The official certifications, training, and licenses that authorize or otherwise pertain to the provision of care by the practitioner.  For example, a medical license issued by a medical board authorizing the practitioner to practice medicine within a certian locality. |
| `entry[] (Practitioner).resource.qualification[].code` | object | Yes | Coded representation of the qualification. |
| `entry[] (Practitioner).resource.qualification[].code.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Practitioner).resource.qualification[].code.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Practitioner).resource.qualification[].code.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Practitioner).resource.qualification[].code.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Practitioner).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Practitioner).search.mode` | string | Yes | Identifies the Practitioner as matching the search parameters. Value: match |
| `entry[] (Other).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Other).search.mode` | string | No | Why this entry is in the result set - whether it's included as a match or because of an _include requirement, or to convey information or warning information about the search process. Possible values: match, include, outcome - why this is in the result set |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "resourceType": "Bundle",
  "type": "searchset",
  "total": 0,
  "entry": [
    {
      "resource": {
        "resourceType": "Practitioner",
        "id": "RedoxPAPractitionerExamplePat",
        "identifier": [
          {
            "system": "http://hl7.org/fhir/sid/us-npi",
            "value": "4356789876"
          }
        ],
        "name": [
          {
            "given": [
              "Pat"
            ],
            "family": "Granite"
          }
        ],
        "address": [
          {
            "line": [
              "123 Main St."
            ],
            "city": "Madison",
            "district": "Dane",
            "state": "WI",
            "postalCode": "53703",
            "country": "USA"
          }
        ],
        "telecom": [
          {
            "value": "+16085551234"
          }
        ]
      },
      "search": {
        "mode": "match"
      }
    }
  ]
}
```

### 400

Request could not be processed or failed validation

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: OperationOutcome |
| `issue` | Array of object | Yes | A structured respresentation of the error that occurred |
| `issue[].severity` | string | Yes | Generally `error` or `fatal` Possible values: fatal, error, warning, information |
| `issue[].code` | string | Yes | A FHIR category code that describes the general type of issue. See http://hl7.org/fhir/ValueSet/issue-type for details |
| `issue[].id` | string | No | If the error occurs in the RedoxEngine, this corresponds to an Error record in the organization. |
| `issue[].details` | object | No | Additional details about the error. This may be a text description of the error or a system code that identifies the error. |
| `issue[].details.coding` | Array of object | No | A more granular FHIR code for the specific error. Typically from http://hl7.org/fhir/ValueSet/operation-outcome |
| `issue[].details.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `issue[].details.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `issue[].details.text` | string | No | A human-readable interpretation of the issue code |
| `issue[].diagnostics` | string | No | Additional diagnostic information about the issue. |

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "invalid",
      "details": {
        "coding": [
          {
            "code": "MSG_BAD_SYNTAX",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid content found in request body."
      }
    }
  ]
}
```

### 401

Authorization is required

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "unknown",
      "details": {
        "coding": [
          {
            "code": "MSG_AUTH_REQUIRED",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid authorization token"
      }
    }
  ]
}
```

### 500

Internal server error

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "processing",
      "details": {
        "coding": [
          {
            "code": "MSG_RESOURCE_ID_FAIL",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Unable to allocate resource id."
      }
    }
  ]
}
```

### 503

Service unavailable

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "transient",
      "details": {
        "text": "System is unable to process this message at this time."
      }
    }
  ]
}
```
